dnl
dnl $ Id: $
dnl

PHP_ARG_ENABLE(cvcapture, whether to enable cvcapture functions,
[  --enable-cvcapture         Enable cvcapture support])

if test "$PHP_CVCAPTURE" != "no"; then

PHP_ARG_WITH(opencv, whether opencv is available,[  --with-opencv[=DIR]  With opencv support])


  
  if test -z "$PKG_CONFIG"
  then
	AC_PATH_PROG(PKG_CONFIG, pkg-config, no)
  fi
  if test "$PKG_CONFIG" = "no"
  then
	AC_MSG_ERROR([required utility 'pkg-config' not found])
  fi

  if ! $PKG_CONFIG --exists opencv
  then
	AC_MSG_ERROR(['opencv' not known to pkg-config])
  fi

  PHP_EVAL_INCLINE(`$PKG_CONFIG --cflags-only-I opencv`)
  PHP_EVAL_LIBLINE(`$PKG_CONFIG --libs opencv`, CVCAPTURE_SHARED_LIBADD)

  export OLD_CPPFLAGS="$CPPFLAGS"
  export CPPFLAGS="$CPPFLAGS $INCLUDES -DHAVE_OPENCV"
  AC_CHECK_HEADER([cv.h], [], AC_MSG_ERROR('cv.h' header not found))
  AC_CHECK_HEADER([highgui.h], [], AC_MSG_ERROR('highgui.h' header not found))
  export CPPFLAGS="$OLD_CPPFLAGS"

  export OLD_CPPFLAGS="$CPPFLAGS"
  export CPPFLAGS="$CPPFLAGS $INCLUDES -DHAVE_CVCAPTURE"

  AC_MSG_CHECKING(PHP version)
  AC_TRY_COMPILE([#include <php_version.h>], [
#if PHP_MAJOR_VERSION < 4 || (PHP_MAJOR_VERSION == 4 && PHP_MINOR_VERSION < 4)
#error  this extension requires at least PHP version 4.4.0
#endif
],
[AC_MSG_RESULT(ok)],
[AC_MSG_ERROR([need at least PHP 4.4.0])])

  export CPPFLAGS="$OLD_CPPFLAGS"


  PHP_SUBST(CVCAPTURE_SHARED_LIBADD)
  AC_DEFINE(HAVE_CVCAPTURE, 1, [ ])

  PHP_NEW_EXTENSION(cvcapture, cvcapture.c , $ext_shared)

fi

